module Algorithmics.Map

type Entry<'key, 'value> =
  { key : 'key; value : 'value }

[<Sealed>]
type Map<'key, 'value when 'key : comparison> =
// to support maps.[key] notation
    member Item : 'key -> 'value with get

val empty    : Map<'key, 'value>
val add      : 'key * 'value -> Map<'key, 'value> -> Map<'key, 'value>
val remove   : 'key -> Map<'key, 'value> -> Map<'key, 'value>
val isEmpty  : Map<'key, 'value> -> bool
val lookup   : 'key -> Map<'key, 'value> -> 'value option
val fromList : ('key * 'value) list -> Map<'key, 'value>
val toList   : Map<'key, 'value> -> ('key * 'value) list
//val toKVList : Map<'key, 'value> -> (Entry<'key, 'value>) list
