(*

fsharpi Mini.fs Algorithmics/BinarySearch.fs Algorithmics/Neighbours.fs

open Algorithmics.Neighbours ;;

*)

module Algorithmics.Neighbours

open Mini

(* requires box (l - 1) <= box l and box r >= box (r + 1) *)

let beatYourNeighbours (box : Int -> Int) (lower : Int, upper : Int) =
  let rec search (l, u) =
    if l = u then u
             else let m = (l + u) / 2
                  if box m <= box (m + 1) then search (m + 1, u)
                                          else search (l, m)
  search (lower, upper)

let boxes1 = [|0; 3; 2; 9; 8; 7; 2; 3; 9; 0|]
let boxes2 = [|0; 4; 2; 7; 6; 5; 3; 9; 8; 1|]

let result =
  beatYourNeighbours (fun i -> boxes2.[i]) (0, boxes2.Length - 1)

open Algorithmics.BinarySearch

let beatYourNeighbours' (box : Int -> Int) =
  intBinarySearch (fun i -> box i > box (i + 1))
