module Algorithmics.PQueue

[<Sealed>]
type PQueue<'elem when 'elem : comparison>

val empty     : PQueue<'elem>
val single    : 'elem -> PQueue<'elem>
val insert    : 'elem * PQueue<'elem> -> PQueue<'elem>
val meld      : PQueue<'elem> * PQueue<'elem> -> PQueue<'elem>
val splitMin  : PQueue<'elem> -> ('elem * PQueue<'elem>) option
val fromList  : 'elem list -> PQueue<'elem>
val toOrdList : PQueue<'elem> -> 'elem list
val sort      : 'elem list -> 'elem list when 'elem : comparison
