(*

fsi Algorithmics/PQueue/Pennant.fs

Pennants aka topped looser trees.

*)

module Algorithmics.Pennant

type Tree<'elem> =
  | Leaf
  | Node of Tree<'elem> * 'elem * Tree<'elem>

type Pennant<'elem> =
  'elem * Tree<'elem>

let versus ((a, t), (b, u)) =
    if a <= b then (a, Node (u, b, t))
              else (b, Node (t, a, u))

let rec spine : Tree<'elem> -> Pennant<'elem> list = function
    | Leaf           -> []
    | Node (t, a, u) -> (a, t) :: spine u
