(*

fsharpc -a Algorithmics/Set/Set.fsi Algorithmics/Set/List.fs

fsharpi -r List.dll
open Algorithmics ;;

An implementation of sets using unordered lists possibly containing
duplicates.

*)

module Algorithmics.Set

// implementation of the interface

type Set<'elem when 'elem : comparison> =
  | Abs of List<'elem>

let empty = Abs []

let add (key, Abs list) = Abs (key :: list)

let remove (key, Abs list) =
  let rec del = function
  | []      -> []
  | x :: xs -> if key = x then del xs else x :: del xs
  in  Abs (del list)

let isEmpty (Abs list) = List.isEmpty list

let contains (key, Abs list) =
  let rec find = function
  | []      -> false
  | x :: xs -> key = x || find xs
  in  find list

let fromList list = Abs list

let toList (Abs list) = list
