(*

fsharpc -a Algorithmics/Set/Set.fsi Algorithmics/Set/OrdList.fs 

fsharpi -r OrdList.dll
open Algorithmics ;;

An implementation of sets using ordered list with no duplicates.

*)

module Algorithmics.Set

// implementation of the interface

type Set<'elem when 'elem : comparison> =
  | Abs of List<'elem>

let empty = Abs []

let add (key, Abs list) =
  let rec ins = function
  | []      -> [key]
  | x :: xs ->
      if   key < x  then key :: x :: xs
      elif key = x  then key :: xs
      else (* key > x *) x :: ins xs
  in Abs (ins list)

let remove (key, Abs list) =
  let rec del = function
  | []      -> []
  | x :: xs ->
      if   key < x then  x :: xs
      elif key = x then  xs
      else (* key > x *) x :: del xs
  in Abs (del list)

let isEmpty (Abs list) = List.isEmpty list

let contains (key, Abs list) =
  let rec find = function
  | []      -> false
  | x :: xs -> key = x || key > x && find xs
  in find list
        
let fromList list = Abs (List.distinct (List.sort list))

let toList (Abs list) = list
