(*

fsharpi Mini.fs Algorithmics/Sort.fs
open Mini ;;
open Algorithmics.Sort ;;

*)
module Algorithmics.Sort

//open Mini

let insertionSort (=<) =
  let rec insert k = function
    | []      -> [k]
    | x :: xs -> if k =< x then k :: x :: xs
                           else x :: insert k xs
  let rec sort = function
    | []      ->  []
    | x :: xs -> insert x (sort xs)
  in sort

let selectionSort (=<) =
  let rec splitMin = function
    | []      -> None
    | x :: xs -> Some (match splitMin xs with
                       | None         -> (x, xs)  // xs = []
                       | Some (m, ys) -> if x =< m then (x, xs)
                                         else (m, x :: ys))
  let rec sort xs =
    match splitMin xs with
      | None         -> []
      | Some (m, ys) -> m :: sort ys
  in sort

let rec unzip = function
  | []      -> ([], [])
  | x :: xs -> let (xs1, xs2) = unzip xs
               (x :: xs2, xs1)

let mergeSort (=<) =
  let rec merge = function
    | ([], xs)
    | (xs, []) -> xs
    | (x :: xs, y :: ys) ->
        if x =< y then x :: merge (xs, y :: ys)
                  else y :: merge (x :: xs, ys)

  let rec sort = function
    | []  -> []
    | [x] -> [x]
    | xs  -> let (xs1, xs2) = unzip xs
             merge (sort xs1, sort xs2)
  in sort

