(*

fsharpi Mini.fs Datatypes/Area.fs

open Datatypes.Area ;;

*)

module Datatypes.Area

open Mini


// Intervalle.

type Interval  =  { lo : Nat; hi : Nat }

let length (i : Interval)  =
    i.hi - i.lo

let shift (d : Nat, i : Interval)  =
    { lo = i.lo + d; hi = i.hi + d }

let intersection (i : Interval, j : Interval)  =
    { lo = max i.lo j.lo; hi = min i.hi j.hi }

let length2 (i : Interval, j : Interval)  =
    length i + length j - length (intersection (i, j))

// Rechtecke.

type Rectangle  =  { x : Interval; y : Interval }

let area (r : Rectangle)  =
    length r.x * length r.y

let Intersection (r : Rectangle, s : Rectangle)  =
    { x = intersection (r.x, s.x);
      y = intersection (r.y, s.y) }
// let (r : Rectangle) ^&&^ (s : Rectangle)  =
let (^&&^)  (r : Rectangle) (s : Rectangle)  =
    { x = intersection (r.x, s.x);
      y = intersection (r.y, s.y) }

// Anwendung.

let area2 (r : Rectangle, s : Rectangle)  =
    area r + area s - area (Intersection (r, s))

let rect1  =
    let i = { lo = 1N; hi = 4N }
    { x = i; y = i }
let rect2  =
    let i = { lo = 2N; hi = 6N }
    { x = shift (1N, i); y = i }

let result = area2 (rect1, rect2)

let Intersection3 (r : Rectangle, s : Rectangle, t : Rectangle)  =
    Intersection (r, Intersection (s, t))
    
let area3 (r : Rectangle, s : Rectangle, t : Rectangle)  =
    area r + area s + area t
    - area (Intersection (r, s))
    - area (Intersection (r, t))
    - area (Intersection (s, t))
    + area (Intersection3 (r, s, t))

let Area3 (r : Rectangle, s : Rectangle, t : Rectangle)  =
    area r + area s + area t
    - area (r ^&&^ s)
    - area (r ^&&^ t)
    - area (s ^&&^ t)
    + area (r ^&&^ s ^&&^ t)
