(*

fsharpi Mini.fs Datatypes/List.fs

open Datatypes.List ;;

*)

module Datatypes.List

open Mini

type Nats =
  | Nil
  | Cons of Nat * Nats

let rec sum (nats : Nats) : Nat =
  match nats with
    | Nil           -> 0N
    | Cons (n, ns)  -> n + sum ns

let rec product (nats : Nats) : Nat =
  match nats with
    | Nil           -> 1N
    | Cons (n, ns)  -> n * product ns

let rec putlast (nats : Nats, nat: Nat) : Nats =
  match nats with
    | Nil           -> Cons (nat, Nil)
    | Cons (n, ns)  -> Cons (n, putlast (ns, nat))

let rec mirror (nats : Nats) : Nats =
  match nats with
    | Nil           -> Nil
    | Cons (n, ns)  -> putlast (mirror ns, n)
