(*

fsharpc Mini.fs Datatypes/Person.fs
mono Person.exe

fsharpi --nowarn:62 Mini.fs Datatypes/Person.fs

open Mini ;;
open Datatypes.Person ;;

*)

module Datatypes.Person
#nowarn "62"

open Mini

type Woman =
  { name : String }

type Man =
  { name : String; bald : Bool }

type Person =
  | Female of Woman
  | Male   of Man

let ralf     = Male   { name = "Ralf"; bald = true }
let melanie  = Female { name = "Melanie" }
let julia    = Female { name = "Julia" }
let andres   = Male   { name = "Andres"; bald = false }

let dear (person: Person) : string =
  match person with
    |  Female  female -> "Liebe "   ^ female.name
    |  Male    male   -> (  if male.bald  
                                then  "Lieber glatzköpfiger "
                                else  "Lieber ")  ^ male.name

putline (dear ralf)
