(*

fsharpi Mini.fs Datatypes/Sort.fs

open Mini ;;
open Datatypes.Sort ;;

*)

module Datatypes.Sort

open Mini

type Nats =
  | Nil
  | Cons of Nat * Nats

let rec insert (nat : Nat, nats : Nats) : Nats =
  match nats with
    | Nil           ->  Cons (nat, Nil)
    | Cons (n, ns)  ->  if nat <= n then Cons (nat, nats)
                                    else Cons (n, insert (nat, ns))

let rec sort (nats : Nats) : Nats =
  match nats with
    | Nil           ->  Nil
    | Cons (n, ns)  ->  insert (n, sort ns)

let sortBy (lessEqual : Nat * Nat -> Bool) : Nats -> Nats =
  let rec insert (nat : Nat, nats : Nats) : Nats =
      match nats with
        | Nil           ->  Cons (nat, Nil)
        | Cons (n, ns)  ->  if lessEqual (nat, n)
                            then  Cons (nat, nats)
                            else  Cons (n, insert (nat, ns))
  let rec sort (nats : Nats) : Nats =
      match nats with
        | Nil           ->  Nil
        | Cons (n, ns)  ->  insert (n, sort ns)
  in sort
