(*

fsharpi Mini.fs Datatypes/WindFarm.fs

open Datatypes.WindFarm ;;

*)

module Datatypes.WindFarm

type Point = { x : Nat; y : Nat }

let windfarm =
  [ { x =  2N; y =  2N};  { x =  6N; y = 18N};  { x =  8N; y = 10N};
    { x = 13N; y =  3N};  { x = 12N; y = 15N};  { x = 26N; y =  6N};
    { x = 22N; y = 16N};  { x = 30N; y = 15N} ]
// position = 13N  

// Minimum und Maximum.

// minBy, maxBy : ('a -> 'b) -> ('a list -> 'a)
let rec minBy (priority : 'a -> Nat) : 'a list -> 'a = function
    | [x]     -> x
    | x :: xs -> let m = minBy priority xs in
                 if priority x <= priority m then x else m

let rec maxBy priority = function
    | [x]     -> x
    | x :: xs -> let m = maxBy priority xs in
                 if priority x <= priority m then m else x

// minBy (fun p -> p.x) windfarm ;;
// maxBy (fun p -> p.y) windfarm ;;

let northSouthRoute ps =
    (maxBy (fun p -> p.y) ps).y - (minBy (fun p -> p.y) ps).y

// Median.

let median xs =
    (List.sort xs).[(List.length xs - 1) / 2]

let rec sumBy (cost : 'a -> Nat) : 'a list -> Nat = function
//let rec sumBy cost = function
    | []      -> 0N
    | x :: xs -> cost x + sumBy cost xs
        
let westEastRoutes ps =
    let m = (median ps).x
    (m, sumBy (fun p -> (p.x - m) + (m - p.x)) ps)

let optimize ps =
    let l1       = northSouthRoute ps
    let (m, l2)  = westEastRoutes ps
    (m, l1 + l2)

// northSouthRoute windfarm ;;
// westEastRoutes windfarm ;;
// let lo = (minBy (fun p -> p.x) windfarm).x ;;
// let hi = (maxBy (fun p -> p.x) windfarm).x ;;
// [ for m in lo .. hi -> List.sumBy (fun p -> (p.x - m) + (m - p.x)) windfarm ] ;;
