(*
Implementation of reference cells using mutables.

fsharpi Mini.fs Effects/Cell.fs
open Effects.Cell ;;
*)

module Effects.Cell

[<ReferenceEquality>]
type Ref<'value> =
    { mutable contents : 'value }

let ref value =
    { contents = value }
let (!) cell =
    cell.contents
let (:=) cell value =
    cell.contents <- value
    value

let test1 () =
    let x = ref 0N
    let y = ref 0N
    x := y := 4711N

let test2 () =
    let x = ref 0N
    let y = ref 0N
    x = y   // this is reference equality
