(*
Counting the number of recursive calls.

fsharpi Mini.fs Effects/CountingFib.fs
open Effects.CountingFib ;;
*)

module Effects.CountingFib

open Mini

let counter = ref 0N

let rec fibonacci (n : Nat) : Nat =
  counter := !counter + 1N
//  if n = 8N then counter := !counter + 1N
  if n <= 1N then n
             else fibonacci (n - 1N) + fibonacci (n - 2N)

let rec counting_fibonacci (n : Nat) : Nat * Nat =
  if n <= 1N then (n, 1N)
             else let (f1, c1) = counting_fibonacci (n - 1N)
                  let (f2, c2) = counting_fibonacci (n - 2N)
                  (f1 + f2, c1 + c2 + 1N)

let rec two_fib (n : Nat) : Nat * Nat =
  if n = 0N then (0N, 1N)
            else let (a, b) = two_fib (n - 1N)
                 (b, a + b)

// using mutables
module Mutable =
  let mutable counter = 0N

  let rec fibonacci (n : Nat) : Nat =
    counter <- counter + 1N
//    if n = 8N then counter := !counter + 1N
    if n <= 1N then n
               else fibonacci (n - 1N) + fibonacci (n - 2N)
