(*
Listing directories and files using list comprehensions.

fsharpi Mini.fs Effects/Files.fs
open Effects.Files ;;
*)

module Effects.Files

open Mini

let rec collect f = function
  | []      -> []
  | x :: xs -> f x @ collect f xs

let test1 =
  [ yield 815
    for i in 0 .. 9 do
      yield i
    yield 4711]
  
let test2 =
  [ yield 815
    for i in 0 .. 9 do
      yield i
      yield 4711]

open System.IO

let rec listFiles dir =
  [ yield! Directory.GetFiles dir;
    for d in Directory.GetDirectories dir do
      yield! listFiles d ]

// listFiles "." ;;
