(*
Mini interpreter in Mini (well, only for arithmetic expressions);
demonstrates read-eval-print_loop (REPL).

fsharpc Mini.fs Grammar/Token.fs Grammar/Expr.fs Grammar/ParserExpr.fs Datatypes/Person.fs Effects/Input.fs Effects/Mini2.fs
mono Mini2.exe

fsharpi Mini.fs Grammar/Token.fs Grammar/Expr.fs Grammar/ParserExpr.fs Datatypes/Person.fs Effects/Input.fs Effects/Mini2.fs
open Effects.Mini2 ;;
mini2() ;;
*)

module Effects.Mini2
#nowarn "62"

open Mini
open Grammar.Expr
open Grammar.ParserExpr
open Effects

let rec read_eval_print_loop () =
    try
      let s = Input.query "Mini-Mini > "
      if s = "" then
        ()
      else if List.contains s ["exit"; "halt"; "q"; "quit"; "stop"] then
        raise EOF
      else
        match Systematic.abstract_syntax_tree s with
        | None   -> putline "syntax error"
        | Some e -> print e; print (evaluate e)
    with
    | Panic s -> putline ("lexical error: " ^ s)
    read_eval_print_loop ()

let mini2 () =
    try
      read_eval_print_loop ()
    with
    | EOF -> putline "bye bye"

let main = mini2 ()
