(*
Exceptions as a control mechanism.

fsharpi Mini.fs Effects/Product.fs
open Effects.Product ;;
*)

module Effects.Product

open Mini

exception Zero

let product (list : List<Nat>) : Nat =
  try
   let rec worker = function
       | []      -> 1N
       | n :: ns -> if n = 0N then raise Zero else n * worker ns
    in
      worker list
  with
  | Zero -> 0N

// product [1N .. 10000N] ;;
// product [0N .. 10000N] ;;
// product [1N .. 100000N] ;;
// product [0N .. 100000N] ;;
