(*
   
fsharpc Mini.fs Grammar/Alphabet.fs

*)

module Grammar.Alphabet

open Mini
open System

type Alphabet = | A | B

let ord (a : Alphabet) : int =
    match a with
    | A -> 0
    | B -> 1

let rec lex (list : List<Char>) : List<Alphabet> =
    match list with
    | []        -> []
    | c :: rest -> 
            if      c = 'A' || c = 'a'  then A :: lex rest
            else if c = 'B' || c = 'b'  then B :: lex rest
            else if Char.IsWhiteSpace c then lex rest
            else                             panic "illegal character"
