(*

fsharpc Mini.fs Grammar/Alphabet.fs Grammar/ByteCode.fs

*)
module Grammar.Bytecode

open Mini

type Control =
  { nullable : Array<Bool>;
    next : Array<Array<int>> }  // Vorlesung: Nat statt int

let control_r00 =
  { nullable = [| false; true; false; true |];
    next = [| [| 0; 0; 1; 1 |];      // A
              [| 2; 2; 3; 3 |] |] }  // B

let generic_accept (ord : 'a -> int, control : Control) : List<'a> -> Bool =
  let rec accept (k : int, input : List<'a>) : Bool =
        match input with
        | []        -> control.nullable.[k]
        | a :: rest -> accept (control.next.[ord a].[k], rest)
  in fun input -> accept (0, input) 

let accept_r00 =
  generic_accept (Alphabet.ord, control_r00)

let test (s : String) : Bool =
  accept_r00 (Alphabet.lex (explode s))
