(*
   
fsharpc Mini.fs Grammar/Alphabet.fs Grammar/Compiled.fs

*)

module Grammar.Compiled

open Mini
open Grammar.Alphabet

// Akzeptor für die Sprache aller Wörter, deren vorletztes
// Symbol ein b ist: (a | b)^* b (a | b).

let rec accept_r00 (input : List<Alphabet>) : Bool =
    match input with
    | []        -> false
    | A :: rest -> accept_r00 rest
    | B :: rest -> accept_r10 rest

and accept_r01 (input : List<Alphabet>) : Bool =
    match input with
    | []        -> true
    | A :: rest -> accept_r00 rest
    | B :: rest -> accept_r10 rest

and accept_r10 (input : List<Alphabet>) : Bool =
    match input with
    | []        -> false
    | A :: rest -> accept_r01 rest
    | B :: rest -> accept_r11 rest

and accept_r11 (input : List<Alphabet>) : Bool =
    match input with
    | []        -> true
    | A :: rest -> accept_r01 rest
    | B :: rest -> accept_r11 rest

// Test.

let test (s : String) : Bool =
  accept_r00 (Alphabet.lex (explode s))
