(*
   
fsharpc Mini.fs Grammar/Expr.fs

*)

module Grammar.Expr

open Mini

type Expr =
    | Const of Nat 
    | Add   of Expr * Expr
    | Mul   of Expr * Expr

let rec evaluate (expr : Expr) : Nat =
  match expr with
  | Const nat          -> nat
  | Add (expr1, expr2) -> evaluate expr1 + evaluate expr2
  | Mul (expr1, expr2) -> evaluate expr1 * evaluate expr2
