(*

fsharpi Mini.fs Grammar/Token.fs

open Mini ;;
open Grammar.Token ;;

*)

module Grammar.Token

open Mini
open System

type Token = | Num of Nat | LParen | RParen | Asterisk | Plus

let rec splitWhile (pred : 'a -> bool) = function
    | [] -> ([], [])
    | a :: rest -> if pred a then
                       let (xs1, xs2) = splitWhile pred rest in (a :: xs1, xs2)
                   else
                       ([], a :: rest)

let rec lex (list : List<Char>) : List<Token> =
    match list with
    | []        -> []
    | c :: rest ->
        if   c = '(' then LParen   :: lex rest
        elif c = ')' then RParen   :: lex rest
        elif c = '*' then Asterisk :: lex rest
        elif c = '+' then Plus     :: lex rest
        elif Char.IsDigit c then
            let (xs1, xs2) = splitWhile Char.IsDigit list
            in  Num (Nat.Parse (implode xs1)) :: lex xs2
        elif Char.IsWhiteSpace c then lex rest
        else panic "illegal character"

// lex (explode "47 + 11 * (08 + 15)") ;; 
