(*
Arithmetic expressions using interfaces and object expresssions.

fsharpi Mini.fs Objects/Expr.fs
open Objects.Expr ;;
*)

module Objects.Expr
#nowarn "62"

open Mini

type IExpr =
  interface
    abstract member Value : Nat
    abstract member Show  : String
  end

let constant (n : Nat) : IExpr =
  { new IExpr with
      member self.Value = n
      member self.Show = show n
  }

let add (expr1 : IExpr, expr2 : IExpr) : IExpr =
  { new IExpr with
      member self.Value = expr1.Value + expr2.Value
      member self.Show = "(" ^ expr1.Show ^ " + " ^ expr2.Show ^ ")"
  }

let mul (expr1 : IExpr, expr2 : IExpr) : IExpr =
  { new IExpr with
      member self.Value = expr1.Value * expr2.Value
      member self.Show = "(" ^ expr1.Show ^ " * " ^ expr2.Show ^ ")"
  }

let sub (expr1 : IExpr, expr2 : IExpr) : IExpr =
  { new IExpr with
      member self.Value = expr1.Value - expr2.Value
      member self.Show = "(" ^ expr1.Show ^ " - " ^ expr2.Show ^ ")"
  }

let e  = add (constant 4711N, mul (constant 815N, constant 2765N))
let e' = mul (constant 4711N, add (constant 815N, constant 2765N))

// e.Value ;;
// e.Show ;;
