(*
Sequence expressions: squares and natural numbers.

fsharpi Mini.fs Objects/Sequence.fs
open Objects.Sequence ;;
*)

module Objects.Sequence
#nowarn "40"

open Mini
open System.Collections.Generic

let sum (xs : seq<Nat>) : Nat =
    let mutable acc = 0N
    for x in xs do
        acc <- acc + x
    acc

let product (xs : seq<int>) =
    let mutable acc = 1
    for x in xs do
        acc <- acc * x
    acc

let squares =
    let rec generate (current, odd) =
      seq { yield current; yield! generate (current + odd, odd + 2) }
    generate (0, 1)

let rec nats =
    seq { yield 0
          for n in nats do
            yield n + 1 }

let squares' =
    seq { for n in nats do yield n * n }

// Seq.takeWhile (fun n -> n < 1000) squares' ;;
