(*
Subtying.

fsharpi Mini.fs Objects/Subtyping.fs
open Objects.Subtyping ;;
*)

module Objects.Subtyping

open Mini

type Phone =
  interface
    abstract member Dial : Nat -> Unit
    abstract member Play : String -> Unit
  end

type MP3Player =
  interface
    abstract member Play : String -> Unit
  end

type Mobile =
  interface
    inherit Phone
    inherit MP3Player
    abstract member Number  : String -> Nat
    abstract member Call    : String -> Unit
  end

type Smart =
  interface
    inherit Mobile
    abstract member Browse : String -> Unit
  end

let aPhone =
    { new Phone with
        member self.Dial n   = printfn "Phone: dialing %s" (show n)
        member self.Play s   = printfn "Phone: playing %s" s
    }

let aMobile =
    { new Mobile with
        member self.Number s = printfn "Mobile: looking %s up" s; 4711N
        member self.Call s   = printfn "Mobile: calling %s" s
      interface MP3Player with
        member self.Play s   = printfn "Mobile - MP3: playing %s" s
      interface Phone with
        member self.Dial n   = printfn "Mobile: dialing %s" (show n)
        member self.Play s   = printfn "Mobile - Phone: playing %s" s
    }

let aSmart =
    { new Smart with
        member self.Browse s = printfn "Smart: browsing %s" s
      interface Mobile with
        member self.Number s = printfn "Smart: looking %s up" s; 4711N
        member self.Call s   = printfn "Smart: calling %s" s
      interface Phone with
        member self.Dial n   = printfn "Smart: dialing %s" (show n)
        member self.Play s   = printfn "Smart - Phone: playing %s" s
      interface MP3Player with
        member self.Play s   = printfn "Smart - MP3: playing %s" s
    }

// die Phone-Methode wird ausgeführt, da inherit Phone als letztes aufgeführt wird?
// aPhone.Play("a");;
// (aPhone :> MP3Player).Play("a");;
// (aPhone :> Phone).Play("a");;    

// pairs
let test1 () =
//    let (mobile1, mobile2) : Mobile * Mobile = (aMobile, aSmart :> Mobile)
    let (mobile1, mobile2) = (aMobile, aSmart)
    mobile1.Call("Hannah")
    mobile2.Call("Lee")

// functions
let repair  (m : Mobile) = m
let upgrade (m : Mobile) = aSmart

let test2 () =
//  (repair aMobile).Call("Holly")
  (upgrade aMobile).Call("Holly")

// reference cells
let test3 () =
//  let case = ref aPhone
//  let case = ref aMobile
  let case = ref aSmart
  (!case).Call("Hannah")

let test4 () =
//  let case = ref aPhone
  let case = ref aMobile
//  let case = ref aSmart
  case := aMobile

let test5 () =
    let mobileCase : Mobile ref = ref aMobile
//    let phoneBox  : Phone ref  = mobileCase  // *not* type correct
    let phoneBox  : Phone ref  = ref aPhone
    phoneBox := aPhone
    (!mobileCase).Play("Siberian Khatru")
// see also Java's array bug
// https://en.wikipedia.org/wiki/Covariance_and_contravariance_%28computer_science%29#Covariant_arrays_in_Java_and_C.23
