(*

fsharpi Mini.fs Values/Leibniz.fs

open Values.Leibniz ;;

*)

module Values.Leibniz

open Mini

let square (n : Nat) : Nat = n * n

let rec factorial (n : Nat) : Nat =
  if n = 0N then 1N 
            else factorial (n - 1N) * n

let rec power (x : Nat, n : Nat) : Nat =
  if n = 0N then 1N
            else if n % 2N = 0N then square (power (x, n / 2N))
                                else square (power (x, n / 2N)) * x

let rec mul (m : Nat, n : Nat) : Nat =
  if m = 0N then 0N
            else if m % 2N = 0N then 2N * mul (m / 2N, n)
                                else 2N * mul (m / 2N, n) + n

let rec squareroot (n : Nat) : Nat =
  if n = 0N then 0N
            else let r = 2N * squareroot (n / 4N) in
                 if n < square (r + 1N) then r else r + 1N

print (squareroot 120N)
