(*

fsharpi Mini.fs Values/Peano.fs

open Values.Peano ;;

*)

module Values.Peano

open Mini

let square (n : Nat) : Nat = n * n

let rec factorial (n : Nat) : Nat =
  if n = 0N
    then 1N
    else factorial (n - 1N) * n

let rec power (x : Nat, n : Nat) : Nat =
  if n = 0N then 1N
            else power (x, n - 1N) * x

let rec mul (m : Nat, n : Nat) : Nat =
  if m = 0N then 0N
            else mul (m - 1N, n) + n

let rec add (m : Nat, n : Nat) : Nat =
  if m = 0N then n
            else add (m - 1N, n) + 1N

let rec squareRoot (n : Nat) : Nat =
  if n = 0N then 0N
            else let r = squareRoot (n - 1N)
                 in  if n < square (r + 1N) then r else r + 1N

let peanoPattern' (zero : Nat, succ : Nat -> Nat) : Nat -> Nat =
  let rec f (n : Nat) : 'a =
    if n = 0N then zero else succ (f (n - 1N)) in f

// Die Funktion `peanoPattern' benutzt ein Konstrukt aus Kapitel 4:
// Typabstraktion.

let peanoPattern<'a> (zero : 'a, succ : 'a -> 'a) : Nat -> 'a =
  let rec f (n : Nat) : 'a =
    if n = 0N then zero else succ (f (n - 1N)) in f

// `factorial2' verwendet Funktionen höherer Ordnung.
let factorial2 (nat : Nat) : Nat =
  peanoPattern<Nat -> Nat> ((fun _n -> 1N), (fun r -> fun n -> n * r (n - 1N))) nat nat

// `factorial3' und `two-factorial' verwenden Paare, siehe ebenfalls
// Kapitel 4.

let factorial3 (nat : Nat) : Nat =
  snd (peanoPattern<Nat * Nat> ((0N, 1N), fun (n, s) -> (n + 1N, (n + 1N) * s)) nat)

let twoFactorial =
  peanoPattern<Nat * Nat> ((0N, 1N), fun (n, s) -> (n + 1N, (n + 1N) * s))

print (factorial 100N)
